<?php
namespace MyMenu\Controllers;

use Zeedhi\Framework\Controller\Simple;
use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DTO\Response;

class Rate extends Simple
{

    protected $entityManager;

    public function __construct($entityManager)
    {
        $this->entityManager = $entityManager;
    }
    public function rateSave(Request $request, Response $response)
    {
        $arr = $request->getRow();
        $checkIfAlreadyBookRegister = $this->checkIfThereIsAval($arr);

        if (count($checkIfAlreadyBookRegister) > 0) {
            $this->updateOldAval($checkIfAlreadyBookRegister[0]['NRAVALIACAOPRATO'], $arr);
        } else {
            $this->insertNewAval($arr);
        }
    }

    public function consSrvSave(Request $request, Response $response)
    {
        $srv = $request->getRow();
        if (isset($srv['isAnon']) && $srv['isAnon']) {
            if ($srv['IDCONSUMO'] === 'S') {
                $this->insertNewServCons($srv);
            } else {
                $this->removeAnonServCons($srv);
            }
        } else {
            $this->loggedServConsSave($srv);
        }
    }

    public function consSave(Request $request, Response $response)
    {
        $plate = $request->getRow();
        if (isset($plate['isAnon']) && $plate['isAnon']) {
            if ($plate['IDCONSUMO'] === 'S') {
                $this->insertNewCons($plate);
            } else {
                $this->removeAnonCons($plate);
            }
        } else {
            $this->loggedConsSave($plate);
        }
    }
    
    public function loggedServConsSave($srv)
    {
        $checkIfAlreadyBookRegister = $this->checkIfThereIsSrvAval($srv);
        if (count($checkIfAlreadyBookRegister) > 0) {
            $this->updateOldSrvCons($checkIfAlreadyBookRegister[0]['NRAVALIACAOSERVICO'], $srv);
        } else {
            $this->insertNewServCons($srv);
        }
    }
    
    public function loggedConsSave($plate)
    {
        $checkIfAlreadyBookRegister = $this->checkIfThereIsAval($plate);
        if (count($checkIfAlreadyBookRegister) > 0) {
            $this->updateOldCons($checkIfAlreadyBookRegister[0]['NRAVALIACAOPRATO'], $plate);
        } else {
            $this->insertNewCons($plate);
        }
    }

    public function checkIfThereIsSrvAval($srv)
    {
        $params = array(
            "CDFILCENTPME" => $srv['CDFILCENTPME'],
            "CDTIPOCARD" => $srv['CDTIPOCARD'],
            "CDFILIAL" => $srv['CDFILIAL'],
            "CDSERVFILI" => $srv['CDSERVFILI'],
            "CDDIETPAD" => $srv['CDDIETPAD'],
            "DTCARDAPIO" => $srv['DTCARDAPIO'],
            "NRUSUARIOAPP" => $srv['NRUSUARIOAPP'],
            "NRLOCALPESQ" => $srv['NRLOCALPESQ'],
            "NRORG" => $srv['NRORG'],
        );

        $conn = $this->entityManager->getConnection();
        $statement = $conn->prepare("SELECT * FROM AVALIACAOSERVICO WHERE (CDFILCENTPME =:CDFILCENTPME OR :CDFILCENTPME IS NULL) AND (CDTIPOCARD =:CDTIPOCARD OR :CDTIPOCARD IS NULL) AND (CDDIETPAD =:CDDIETPAD OR :CDDIETPAD IS NULL) AND (CDFILIAL =:CDFILIAL OR :CDFILIAL IS NULL) AND (CDSERVFILI =:CDSERVFILI OR :CDSERVFILI IS NULL) AND (DTCARDAPIO =:DTCARDAPIO OR :DTCARDAPIO IS NULL) AND (NRUSUARIOAPP =:NRUSUARIOAPP OR :NRUSUARIOAPP IS NULL) AND (NRORG =:NRORG OR :NRORG IS NULL) AND (NRLOCALPESQ =:NRLOCALPESQ OR :NRLOCALPESQ IS NULL)");
        $statement->execute($params);
        return $statement->fetchAll();
    }
    
    public function checkIfThereIsAval($plate)
    {
        $params = array(
            "CDFILCENTPME" => $plate['CDFILCENTPME'],
            "CDTIPOCARD" => $plate['CDTIPOCARD'],
            "NRCARDPME" => $plate['NRCARDPME'],
            "CDFILIAL" => $plate['CDFILIAL'],
            "CDSERVFILI" => $plate['CDSERVFILI'],
            "NRCARDAPIO" => $plate['NRCARDAPIO'],
            "CDDIETPAD" => $plate['CDDIETPAD'],
            "NRSEQPRATCAR" => $plate['NRSEQPRATCAR'],
            "CDFILAUXPRAT" => $plate['CDFILAUXPRAT'],
            "CDPRATO" => $plate['CDPRATO'],
            "DTCARDAPIO" => $plate['DTCARDAPIO'],
            "CDTIPOPRAT" => $plate['CDTIPOPRAT'],
            "NRUSUARIOAPP" => $plate['NRUSUARIOAPP'],
            "NRLOCALPESQ" => $plate['NRLOCALPESQ'],
            "NRORG" => $plate['NRORG'],
        );

        $conn = $this->entityManager->getConnection();
        $statement = $conn->prepare("SELECT * FROM AVALIACAOPRATO WHERE (CDFILCENTPME =:CDFILCENTPME OR :CDFILCENTPME IS NULL) AND (CDTIPOCARD =:CDTIPOCARD OR :CDTIPOCARD IS NULL) AND (NRCARDPME =:NRCARDPME OR :NRCARDPME IS NULL) AND (CDDIETPAD =:CDDIETPAD OR :CDDIETPAD IS NULL) AND (CDFILIAL =:CDFILIAL OR :CDFILIAL IS NULL) AND (CDSERVFILI =:CDSERVFILI OR :CDSERVFILI IS NULL) AND (NRCARDAPIO =:NRCARDAPIO OR :NRCARDAPIO IS NULL) AND (NRSEQPRATCAR =:NRSEQPRATCAR OR :NRSEQPRATCAR IS NULL) AND (CDFILAUXPRAT =:CDFILAUXPRAT OR :CDFILAUXPRAT IS NULL) AND (CDPRATO =:CDPRATO OR :CDPRATO IS NULL) AND (DTCARDAPIO =:DTCARDAPIO OR :DTCARDAPIO IS NULL) AND (CDTIPOPRAT =:CDTIPOPRAT OR :CDTIPOPRAT IS NULL) AND (NRUSUARIOAPP =:NRUSUARIOAPP OR :NRUSUARIOAPP IS NULL) AND (NRORG =:NRORG OR :NRORG IS NULL) AND (NRLOCALPESQ =:NRLOCALPESQ OR :NRLOCALPESQ IS NULL)");
        $statement->execute($params);
        return $statement->fetchAll();
    }

    public function insertNewServCons($srv)
    {
        $params = array(
            "NRORGNOVOCODIGO" => $srv['NRORG'],
            "IDCONSUMO" => $srv['IDCONSUMO'],
            "CDFILCENTPME" => $srv['CDFILCENTPME'],
            "CDTIPOCARD" => $srv['CDTIPOCARD'],
            "CDFILIAL" => $srv['CDFILIAL'],
            "CDSERVFILI" => $srv['CDSERVFILI'],
            "CDDIETPAD" => $srv['CDDIETPAD'],
            "DTCARDAPIO" => $srv['DTCARDAPIO'],
            "NRUSUARIOAPP" => $srv['NRUSUARIOAPP'],
            "NMUSUARIO" => $srv['NMUSUARIO'],
            "HRCONSUMO" => $srv['HRCONSUMO'],
            "DSCONSUMO" => $srv['DSCONSUMO'],
            "NRLOCALPESQ" => $srv['NRLOCALPESQ'],
            "NRORG" => $srv['NRORG'],
        );
        $conn = $this->entityManager->getConnection();
        $statement = $conn->prepare("
            DECLARE V_SEQUENCIAL VARCHAR2(20);
            BEGIN NOVO_CODIGO('AVALIACAOSERVICO', V_SEQUENCIAL,1,:NRORGNOVOCODIGO);
            INSERT INTO AVALIACAOSERVICO
                (NRAVALIACAOSERVICO, IDCONSUMO, CDFILCENTPME, CDTIPOCARD,  CDFILIAL, CDSERVFILI, CDDIETPAD, DTCARDAPIO, NRUSUARIOAPP, NMUSUARIO, HRCONSUMO, DSCONSUMO, NRLOCALPESQ, NRORG)
            VALUES
                (TO_NUMBER(V_SEQUENCIAL), :IDCONSUMO, :CDFILCENTPME, :CDTIPOCARD, :CDFILIAL, :CDSERVFILI, :CDDIETPAD, :DTCARDAPIO, :NRUSUARIOAPP, :NMUSUARIO, :HRCONSUMO, :DSCONSUMO, :NRLOCALPESQ, :NRORG);
            END;
                ");
        $statement->execute($params);
    }

    public function insertNewCons($plate)
    {
        $params = array(
            "NRORGNOVOCODIGO" => $plate['NRORG'],
            "CDFILCENTPME" => $plate['CDFILCENTPME'],
            "CDTIPOCARD" => $plate['CDTIPOCARD'],
            "NRCARDPME" => $plate['NRCARDPME'],
            "CDFILIAL" => $plate['CDFILIAL'],
            "CDSERVFILI" => $plate['CDSERVFILI'],
            "NRCARDAPIO" => $plate['NRCARDAPIO'],
            "CDDIETPAD" => $plate['CDDIETPAD'],
            "IDCONSUMO" => $plate['IDCONSUMO'],
            "NRSEQPRATCAR" => $plate['NRSEQPRATCAR'],
            "CDFILAUXPRAT" => $plate['CDFILAUXPRAT'],
            "CDPRATO" => $plate['CDPRATO'],
            "DTCARDAPIO" => $plate['DTCARDAPIO'],
            "CDTIPOPRAT" => $plate['CDTIPOPRAT'],
            "NRUSUARIOAPP" => $plate['NRUSUARIOAPP'],
            "NMUSUARIO" => $plate['NMUSUARIO'],
            "HRCONSUMO" => $plate['HRCONSUMO'],
            "DSCONSUMO" => $plate['DSCONSUMO'],
            "NRLOCALPESQ" => $plate['NRLOCALPESQ'],
            "NRORG" => $plate['NRORG'],
        );
        $conn = $this->entityManager->getConnection();
        $statement = $conn->prepare("
                DECLARE V_SEQUENCIAL VARCHAR2(20);
                BEGIN NOVO_CODIGO('AVALIACAOPRATO', V_SEQUENCIAL,1,:NRORGNOVOCODIGO);
                INSERT INTO AVALIACAOPRATO
                    (NRAVALIACAOPRATO, CDFILCENTPME, CDTIPOCARD, NRCARDPME, CDFILIAL, CDSERVFILI, NRCARDAPIO, CDDIETPAD, IDCONSUMO, NRSEQPRATCAR, CDFILAUXPRAT, CDPRATO, CDTIPOPRAT,  NRUSUARIOAPP, NMUSUARIO, HRCONSUMO, DSCONSUMO, DTCARDAPIO, NRLOCALPESQ, NRORG)
                VALUES
                    (TO_NUMBER(V_SEQUENCIAL), :CDFILCENTPME, :CDTIPOCARD, :NRCARDPME, :CDFILIAL, :CDSERVFILI, :NRCARDAPIO, :CDDIETPAD, :IDCONSUMO, :NRSEQPRATCAR, :CDFILAUXPRAT, :CDPRATO, :CDTIPOPRAT, :NRUSUARIOAPP, :NMUSUARIO, :HRCONSUMO, :DSCONSUMO, :DTCARDAPIO, :NRLOCALPESQ, :NRORG);
                END;
                ");
        $statement->execute($params);
    }

    public function removeAnonServCons($srv)
    {
        $SQL = "DELETE FROM AVALIACAOSERVICO WHERE ( CDFILCENTPME =:CDFILCENTPME OR :CDFILCENTPME IS NULL ) AND ( CDTIPOCARD =:CDTIPOCARD OR :CDTIPOCARD IS NULL ) AND ( CDDIETPAD =:CDDIETPAD OR :CDDIETPAD IS NULL ) AND ( CDFILIAL =:CDFILIAL OR :CDFILIAL IS NULL ) AND ( CDSERVFILI =:CDSERVFILI OR :CDSERVFILI IS NULL )  AND ( DTCARDAPIO =:DTCARDAPIO OR :DTCARDAPIO IS NULL ) AND ( NRUSUARIOAPP =:NRUSUARIOAPP OR :NRUSUARIOAPP IS NULL ) AND ( IDCONSUMO =:IDCONSUMO OR :IDCONSUMO IS NULL ) AND ( NRORG =:NRORG OR :NRORG IS NULL ) AND (NMUSUARIO = :NMUSUARIO) AND (HRCONSUMO = :HRCONSUMO) AND (NRLOCALPESQ =:NRLOCALPESQ) AND ROWNUM < 2";
        $params = array(
            "HRCONSUMO" => $srv['HRCONSUMO'],
            "NMUSUARIO" => $srv['NMUSUARIO'],
            "CDFILCENTPME" => $srv['CDFILCENTPME'],
            "CDTIPOCARD" => $srv['CDTIPOCARD'],
            "CDDIETPAD" => $srv['CDDIETPAD'],
            "CDFILIAL" => $srv['CDFILIAL'],
            "CDSERVFILI" => $srv['CDSERVFILI'],
            "DTCARDAPIO" => $srv['DTCARDAPIO'],
            "NRUSUARIOAPP" => $srv['NRUSUARIOAPP'],
            "NMUSUARIO" => $srv['NMUSUARIO'],
            "HRCONSUMO" => $srv['HRCONSUMO'],
            "NRLOCALPESQ" => $srv['NRLOCALPESQ'],
            "IDCONSUMO" => 'S',
            "NRORG" => $srv['NRORG'],
        );
        $conn = $this->entityManager->getConnection();
        $statement = $conn->prepare($SQL);
        $statement->execute($params);
    }
    
    public function removeAnonCons($plate)
    {
        $SQL = "DELETE FROM AVALIACAOPRATO WHERE ( CDFILCENTPME =:CDFILCENTPME OR :CDFILCENTPME IS NULL ) AND ( CDTIPOCARD =:CDTIPOCARD OR :CDTIPOCARD IS NULL ) AND ( NRCARDPME =:NRCARDPME OR :NRCARDPME IS NULL ) AND ( CDDIETPAD =:CDDIETPAD OR :CDDIETPAD IS NULL ) AND ( CDFILIAL =:CDFILIAL OR :CDFILIAL IS NULL ) AND ( CDSERVFILI =:CDSERVFILI OR :CDSERVFILI IS NULL ) AND ( NRCARDAPIO =:NRCARDAPIO OR :NRCARDAPIO IS NULL ) AND ( NRSEQPRATCAR =:NRSEQPRATCAR OR :NRSEQPRATCAR IS NULL ) AND ( CDFILAUXPRAT =:CDFILAUXPRAT OR :CDFILAUXPRAT IS NULL ) AND ( CDPRATO =:CDPRATO OR :CDPRATO IS NULL ) AND ( DTCARDAPIO =:DTCARDAPIO OR :DTCARDAPIO IS NULL ) AND ( CDTIPOPRAT =:CDTIPOPRAT OR :CDTIPOPRAT IS NULL ) AND ( NRUSUARIOAPP =:NRUSUARIOAPP OR :NRUSUARIOAPP IS NULL ) AND ( IDCONSUMO =:IDCONSUMO OR :IDCONSUMO IS NULL ) AND ( NRORG =:NRORG OR :NRORG IS NULL ) AND (NMUSUARIO = :NMUSUARIO) AND (HRCONSUMO = :HRCONSUMO) AND (NRLOCALPESQ = :NRLOCALPESQ) AND ROWNUM < 2";
        $params = array(
            "CDFILCENTPME" => $plate['CDFILCENTPME'],
            "CDTIPOCARD" => $plate['CDTIPOCARD'],
            "NRCARDPME" => $plate['NRCARDPME'],
            "CDDIETPAD" => $plate['CDDIETPAD'],
            "CDFILIAL" => $plate['CDFILIAL'],
            "CDSERVFILI" => $plate['CDSERVFILI'],
            "NRCARDAPIO" => $plate['NRCARDAPIO'],
            "NRSEQPRATCAR" => $plate['NRSEQPRATCAR'],
            "CDFILAUXPRAT" => $plate['CDFILAUXPRAT'],
            "CDPRATO" => $plate['CDPRATO'],
            "DTCARDAPIO" => $plate['DTCARDAPIO'],
            "CDTIPOPRAT" => $plate['CDTIPOPRAT'],
            "NRUSUARIOAPP" => $plate['NRUSUARIOAPP'],
            "NMUSUARIO" => $plate['NMUSUARIO'],
            "HRCONSUMO" => $plate['HRCONSUMO'],
            "NRLOCALPESQ" => $plate['NRLOCALPESQ'],
            "IDCONSUMO" => 'S',
            "NRORG" => $plate['NRORG'],
        );
        $conn = $this->entityManager->getConnection();
        $statement = $conn->prepare($SQL);
        $statement->execute($params);
    }

    public function updateOldSrvCons($oldReg, $srv)
    {
        $params = array(
            "IDCONSUMO" => $srv['IDCONSUMO'],
            "NRAVALIACAOSERVICO" => $oldReg,
            "HRCONSUMO" => isset($srv['HRCONSUMO'])? $srv['HRCONSUMO'] : null,
            "DSCONSUMO" => isset($srv['DSCONSUMO'])? $srv['DSCONSUMO'] : null,
        );
        $conn = $this->entityManager->getConnection();
        $statement = $conn->prepare("UPDATE AVALIACAOSERVICO SET IDCONSUMO = :IDCONSUMO, HRCONSUMO = :HRCONSUMO, DSCONSUMO = :DSCONSUMO WHERE NRAVALIACAOSERVICO = :NRAVALIACAOSERVICO");
        $statement->execute($params);
    }

    public function updateOldCons($oldReg, $plate)
    {
        
        $HRCONSUMO = isset($plate['HRCONSUMO']) ? $plate['HRCONSUMO'] : null;
        $DSCONSUMO = isset($plate['DSCONSUMO']) ? $plate['DSCONSUMO'] : null;
        $params = array(
            "IDCONSUMO" => $plate['IDCONSUMO'],
            "NRAVALIACAOPRATO" => $oldReg,
            "HRCONSUMO" => $HRCONSUMO,
            "DSCONSUMO" => $DSCONSUMO,
        );
        $conn = $this->entityManager->getConnection();
        $statement = $conn->prepare("UPDATE AVALIACAOPRATO SET IDCONSUMO = :IDCONSUMO, HRCONSUMO = :HRCONSUMO, DSCONSUMO = :DSCONSUMO WHERE NRAVALIACAOPRATO = :NRAVALIACAOPRATO");
        $statement->execute($params);
    }

    public function insertNewAval($plate)
    {
        $params = array(
            "NRORGNOVOCODIGO" => $plate['NRORG'],
            "CDFILCENTPME" => $plate['CDFILCENTPME'],
            "CDTIPOCARD" => $plate['CDTIPOCARD'],
            "NRCARDPME" => $plate['NRCARDPME'],
            "CDFILIAL" => $plate['CDFILIAL'],
            "CDSERVFILI" => $plate['CDSERVFILI'],
            "NRCARDAPIO" => $plate['NRCARDAPIO'],
            "CDDIETPAD" => $plate['CDDIETPAD'],
            "NRSEQPRATCAR" => $plate['NRSEQPRATCAR'],
            "CDFILAUXPRAT" => $plate['CDFILAUXPRAT'],
            "CDPRATO" => $plate['CDPRATO'],
            "DTCARDAPIO" => $plate['DTCARDAPIO'],
            "CDTIPOPRAT" => $plate['CDTIPOPRAT'],
            "VRAVALIACAOPRATO" => $plate['VRAVALIACAOPRATO'],
            "DSAVALIACAOPRATO" => isset($plate['DSAVALIACAOPRATO']) ? $plate['DSAVALIACAOPRATO'] : null,
            "NRUSUARIOAPP" => $plate['NRUSUARIOAPP'],
            "NRLOCALPESQ" => $plate['NRLOCALPESQ'],
            "NRORG" => $plate['NRORG'],
        );
        $conn = $this->entityManager->getConnection();
        $statement = $conn->prepare("
                DECLARE V_SEQUENCIAL VARCHAR2(20);
                BEGIN NOVO_CODIGO('AVALIACAOPRATO', V_SEQUENCIAL,1,:NRORGNOVOCODIGO);
                INSERT INTO AVALIACAOPRATO
                    (NRAVALIACAOPRATO, CDFILCENTPME, CDTIPOCARD, NRCARDPME, CDFILIAL, CDSERVFILI, NRCARDAPIO, CDDIETPAD, NRSEQPRATCAR, CDFILAUXPRAT, CDPRATO, CDTIPOPRAT, VRAVALIACAOPRATO, DSAVALIACAOPRATO, NRUSUARIOAPP, DTCARDAPIO, NRLOCALPESQ, NRORG)
                VALUES
                    (TO_NUMBER(V_SEQUENCIAL), :CDFILCENTPME, :CDTIPOCARD, :NRCARDPME, :CDFILIAL, :CDSERVFILI, :NRCARDAPIO, :CDDIETPAD, :NRSEQPRATCAR, :CDFILAUXPRAT, :CDPRATO, :CDTIPOPRAT, :VRAVALIACAOPRATO, :DSAVALIACAOPRATO, :NRUSUARIOAPP, :DTCARDAPIO, :NRLOCALPESQ, :NRORG);
                END;
                ");
        $statement->execute($params);
    }

    public function updateOldAval($oldReg, $plate)
    {
        $params = array(
            "VRAVALIACAOPRATO" => $plate['VRAVALIACAOPRATO'],
            "DSAVALIACAOPRATO" => isset($plate['DSAVALIACAOPRATO']) ? $plate['DSAVALIACAOPRATO'] : null,
            "NRAVALIACAOPRATO" => $oldReg,
        );
        $conn = $this->entityManager->getConnection();
        $statement = $conn->prepare("UPDATE AVALIACAOPRATO SET VRAVALIACAOPRATO = :VRAVALIACAOPRATO, DSAVALIACAOPRATO = :DSAVALIACAOPRATO WHERE NRAVALIACAOPRATO = :NRAVALIACAOPRATO");
        $statement->execute($params);
    }

}
